#include <bits/stdc++.h>

using namespace std;

vector<int> match;
vector<bool> seen;

bool find(int j, const vector<vector<int>>& g) {
    if (match[j] == -1) return 1;
    seen[j] = 1;
    int di = match[j];
    for (auto& e : g[di]) {
        if (!seen[e] && find(e, g)) {
            match[e] = di;
            return 1;
        }
    }
    return 0;
}

int dfs_matching(vector<vector<int>>& g, int n, int m) {
    match.assign(m, -1);
    for (int i = 0; i < n; i++) {
        seen.assign(m, 0);
        for (auto& j : g[i])
            if (find(j, g)) {
                match[j] = i;
                break;
            }
    }
    return (n+m)-(m - (int)count(match.begin(), match.end(), -1));
    /*vector<vector<int>> graf(n+m);
    for (int i = 0; i < n; i++) for (int j : g[i]) {
        graf[i].push_back(j+n);
        graf[j+n].push_back(i);
    }
    vector<int> visited(n+m);
    int ans = 0;
    for (int i = 0; i < n+m; i++) if (!visited[i]) {
        int va=0, vb=0;
        stack<int> s; s.push(i);
        while (!s.empty()) {
            int x = s.top(); s.pop();
            if (visited[x]) continue;
            visited[x] = true;
            if (x<n) va++;
            else vb++;
            for (int j : graf[x]) s.push(j);
        }
        ans += max(va, vb);
        //6 cout << ans << endl;
    }*/
    //cout << "------" << endl;
    //return ans;
}

int main() {
    int n, m; cin >> n >> m;
    //if (n == 2 && m ==1) {
    //    cout << 1 << endl;
    //    return 0;
    //}

    vector<vector<int>> graf(n), reg(n);
    for (int i = 0; i < m; i++) {
        int x, y; cin >> x >> y; x--; y--;
        graf[x].push_back(y);
        reg[y].push_back(x);
    }
    int start; for (int i = 0; i < n; i++) if (reg[i].size() == 0) start=i;
    unordered_map<int, int> S, M;
    S[start] = 0;
    vector<int> in(n);
    for (int i = 0; i < n; i++) in[i] = reg[i].size();
    int ans = 0;
    while (true) {
        //for (auto p : S) cout << p.first << ' '; cout << endl;
        int I = 0;
        for (auto p : S) for (int j : graf[p.first]) {
            in[j]--;
            if (in[j] == 0) {
           // cout<<j<<endl;
                M[j] = I;
                I++;
            }
        }
        if (M.size() == 0) break;
        vector<vector<int>> g(S.size());
        for (auto p : S) for (int j : graf[p.first]) if (M.find(j) != M.end()) g[p.second].push_back(M[j]);
        ans += dfs_matching(g, S.size(), M.size());
        //cout << ans << endl;
        S = M;
        M = unordered_map<int, int>();
    }
    cout << m-ans << endl;
}
